/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest{}

// AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest struct for AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest
type AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest struct {
	Service *string                      `json:"service,omitempty"`
	Data    *LinkedinStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest instantiates a new AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest() *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest {
	this := AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest{}
	var service string = "linkedin_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest {
	this := AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest{}
	var service string = "linkedin_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) GetData() LinkedinStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret LinkedinStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) GetDataOk() (*LinkedinStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given LinkedinStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) SetData(v LinkedinStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest struct {
	value *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) Get() *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) Set(val *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest(val *AppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) *NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerLinkedinStaticLinkedinStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
